--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- emClassChanger
-- クラスチェンジ時装備自動変更
-- Version 0.01b
-- written by エミファ
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
local emClassChanger = {};
_G.emClassChanger = emClassChanger;
local frame = _G.emClassChanger_Frame;

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- バージョンなど
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
local EMCC_MYNAME = "emClassChanger";
local EMCC_VERSION = "emClassChanger Version 0.01b";
local EMCC_VER_AM = "v0.01b";
local EMCC_DIR = "Interface/Addons/emClassChanger/";
local EMCC_EXT = ".lua";
local EMCC_PR_LOCALE = "locales/emClassChanger.";
local EMCC_LOADED = false;
local EMCC_INTERVAL_LEN = 4;
EMCC_STRING = {};

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 現在の動作モード
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
local EMCC_MODE = {};
	EMCC_MODE["NONE"] 	 = 0;	-- 何もしない
	EMCC_MODE["PUTON"]   = 1;	-- 着る
	EMCC_MODE["PULLOFF"] = 2;	-- 脱ぐ
local g_emccMode = EMCC_MODE["NONE"];

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- スラッシュコマンド
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
SLASH_emClassChanger1 = "/emClassChanger";
SLASH_emClassChanger2 = "/emcc";
SlashCmdList[ EMCC_MYNAME ] = function(editBox, msg)
	if ( g_emccMode == EMCC_MODE["NONE"] ) then
		if ( emccConfig_Frame:IsVisible() ) then
			-- 表示されてれば一度消す
			emccConfig_Frame:Hide();
		end
	
		-- フレームを表示
		emccConfig_Frame:Show();
	else
		DEFAULT_CHAT_FRAME:AddMessage( EMCC_STRING["NOOPEN"] );
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- やってみたかっただけの多言語対応(多国で動くかまでは知らない)
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:LoadLanguage()
	local lang = string.sub( GetLanguage():upper(), 1, 2 );
	local localeFileName = EMCC_DIR..EMCC_PR_LOCALE..string.upper(lang)..EMCC_EXT;
	local func, err = loadfile(localeFileName);
	if (err) then
		dofile( EMCC_DIR..EMCC_PR_LOCALE.."EN"..EMCC_EXT );
	else
		dofile( localeFileName );
	end
end

emClassChanger:LoadLanguage();

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- プロファイル関連
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
local g_emccChar = "";
local g_emccRealm = "";
local EMCC_DEF_INTERVAL = 0.5;
local EMCC_NIN_INTERVAL = 0.1;
local EMCC_MAX_INTERVAL = 1.0;
local EMCC_KEY_INTERVAL = "Interval";	-- インターバル
local EMCC_KEY_NOCHANE = "NoChange";	-- インターバル
local EMCC_KEY_HEAD 	= 1;	-- 頭
local EMCC_KEY_HAND 	= 2;	-- 手
local EMCC_KEY_FOOT 	= 3;	-- 足
local EMCC_KEY_CHEST 	= 4;	-- 胸
local EMCC_KEY_LEG 		= 5;	-- 脚
local EMCC_KEY_CAPE 	= 6;	-- マント
local EMCC_KEY_BELT 	= 7;	-- ベルト
local EMCC_KEY_SHOULDER = 8;	-- 肩
local EMCC_KEY_NECK 	= 9;	-- 首
local EMCC_KEY_AMMO 	= 10;	-- 弾
local EMCC_KEY_RANGE 	= 11;	-- 遠隔
local EMCC_KEY_RINGR 	= 12;	-- 指輪（右）
local EMCC_KEY_RINGL 	= 13;	-- 指輪(左)	
local EMCC_KEY_EARR 	= 14;	-- 耳（右）
local EMCC_KEY_EARL 	= 15;	-- 耳（左）
local EMCC_KEY_MAINARM 	= 16;	-- 右手
local EMCC_KEY_OFFHAND 	= 17;	-- 左手

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- スロット
-- 共用する装備にあわせて調整
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
local EMCC_FIRST_SLOT = 1;
local EMCC_LAST_SLOT = 17;
local g_emccFirstSlot = 0;	-- 最初の共有装備の位置
local g_emccLastSlot = 0;	-- 最後の共有装備の位置

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- バッグスロットサーチ範囲
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
local EMCC_SEARCH_START = 1;
local EMCC_SEARCH_END   = 180;

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- カウンタ
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
local g_emccSlotCnt = 0;
local g_emccRemaining = EMCC_DEF_INTERVAL;

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 有効スロットチェック
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:CheckValidSlot()
	for k = EMCC_FIRST_SLOT, EMCC_LAST_SLOT do
		if ( EMCC_PROFILES[g_emccRealm][g_emccChar][k] ~= "" ) then
			g_emccFirstSlot = k;
			break;
		end
	end
	for k = EMCC_FIRST_SLOT, EMCC_LAST_SLOT do
		if ( EMCC_PROFILES[g_emccRealm][g_emccChar][k] ~= "" ) then
			g_emccLastSlot = k;
		end
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 設定読み込み
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:LoadProfile()
	-- プロファイルそのものがなければつくる
	if (not EMCC_PROFILES) then
		EMCC_PROFILES={};
	end
	
	-- サーバごとのプロファイルがなければつくる
	g_emccRealm = GetCurrentRealm();
	if (not EMCC_PROFILES[g_emccRealm]) then
		EMCC_PROFILES[g_emccRealm]={};
	end
	
	-- キャラごとのプロファイルがなければつくる
	g_emccChar = UnitName("player");
	if (not EMCC_PROFILES[g_emccRealm][g_emccChar]) then
		EMCC_PROFILES[g_emccRealm][g_emccChar] = {};
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_INTERVAL] = EMCC_DEF_INTERVAL;
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_NOCHANE] = false;
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_HEAD] 	= "";	-- 頭
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_HAND] 	= "";	-- 手
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_FOOT] 	= "";	-- 足
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_CHEST] 	= "";	-- 胸
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_LEG] 	= "";	-- 脚
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_CAPE] 	= "";	-- マント
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_BELT] 	= "";	-- ベルト
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_SHOULDER]	= "";	-- 肩
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_NECK] 	= "";	-- 首
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_AMMO] 	= "";	-- 弾
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_RANGE] 	= "";	-- 遠隔
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_RINGR] 	= "";	-- 指輪（右）
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_RINGL] 	= "";	-- 指輪(左)	
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_EARR] 	= "";	-- 耳（右）
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_EARL] 	= "";	-- 耳（左）
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_MAINARM] = "";	-- 右手
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_OFFHAND] = "";	-- 左手
	end	
	-- インターバルの範囲チェック
	if ( EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_INTERVAL] < EMCC_NIN_INTERVAL ) then
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_INTERVAL] = EMCC_NIN_INTERVAL;
	end
	if ( EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_INTERVAL] > EMCC_MAX_INTERVAL ) then
		EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_INTERVAL] = EMCC_MAX_INTERVAL;
	end
	
	-- スロットチェック
	emClassChanger:CheckValidSlot();
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- イベント登録
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
frame:RegisterEvent( "VARIABLES_LOADED" );
frame:RegisterEvent( "LOADING_END" );
frame:RegisterEvent( "EXCHANGECLASS_SHOW" );
frame:RegisterEvent( "EXCHANGECLASS_SUCCESS" );
frame:RegisterEvent( "SWAP_EQUIPMENT_SUCCESS" );
frame:RegisterEvent( "PLAYER_INVENTORY_CHANGED" );
SaveVariables( "EMCC_PROFILES" );

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- イベントハンドラ
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:OnEvent( event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 )
	self[event]( self, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 );
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- ロード時
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:VARIABLES_LOADED()
	DEFAULT_CHAT_FRAME:AddMessage( EMCC_STRING["LOADED"] );
	emClassChanger:RegistAddonManager();
end
function emClassChanger:LOADING_END()
	emClassChanger:LoadProfile();
	EMCC_LOADED = true;
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- クラス変更
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:EXCHANGECLASS_SHOW()
	ExchangeClass( EXCHANGECLASS_SUBCLASS, EXCHANGECLASS_MAINCLASS );
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- クラス変更後に共用装備を外し、装備ページを切り替える
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:EXCHANGECLASS_SUCCESS()
	if ( EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_NOCHANE] == false ) then
		-- 装備変更してくださいね
		emClassChanger:SwapEquipment();
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 共用装備を外し、装備ページを切り替える
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:SwapEquipment()
	if ( emccConfig_Frame:IsVisible() ) then
		-- 表示されてれば一度消す
		emccConfig_Frame:Hide();
	end

	if ( ( g_emccFirstSlot == 0 ) and ( g_emccLastSlot == 0 ) ) then
		-- 変更する共有装備がなれけば、装備チャンネルだけ切り替える
		DEFAULT_CHAT_FRAME:AddMessage( EMCC_STRING["EQUIP_CHANNEL"] );
		SwapEquipmentItem();
	else
		-- タイマー処理に脱ぐのを任せる
		g_emccMode = EMCC_MODE["PULLOFF"];
		g_emccSlotCnt = g_emccFirstSlot;
		DEFAULT_CHAT_FRAME:AddMessage( EMCC_STRING["EQUIP_START"] );
	end
end
	
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 装備ページ切り替え後に共用装備をつける
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:SWAP_EQUIPMENT_SUCCESS()
	if ( g_emccMode == EMCC_MODE["PUTON"] ) then
		-- モードPUTONならPULLOFFを経由しての装備ページ切り替えとみなし
		-- カウンタを操作して、タイマーに装備着用をゆだねる
		g_emccSlotCnt = g_emccFirstSlot;
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- タイマー処理
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:OnUpdate( elapsed )
	if ( EMCC_LOADED == false ) then
		-- 初期化前は何もしない
		return;
	end
	if ( ( EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_NOCHANE] == false ) and
		 ( g_emccFirstSlot > 0 ) and ( g_emccLastSlot > 0 ) )
	then
		-- 自動装備が有効なら
		g_emccRemaining = g_emccRemaining - elapsed;
		if ( g_emccRemaining > 0 ) then
			-- 周期が過ぎていないのでなにもせずに返す
			return;
		end
		
		-- 装備着脱処理
		if ( g_emccSlotCnt > 0 ) then
			while ( g_emccSlotCnt <= g_emccLastSlot ) do
				-- 現在のスロットが着脱範囲内なら着脱処理を行う
				if ( emClassChanger:EquipShareItem() ) then
					-- 一件でも着脱したらループを抜ける処理を待つ
					break;
				end
			end
			
			if ( g_emccSlotCnt > g_emccLastSlot ) then
				-- 着脱処理が完了していれば、カウンタをリセットする
				g_emccSlotCnt = 0;
				if ( g_emccMode == EMCC_MODE["PULLOFF"] ) then
					-- 脱ぎ終わったのでモードをPUTONにし装備ページを切り替える
					-- SWAP_EQUIPMENT_SUCCESSイベントに移行
					g_emccMode = EMCC_MODE["PUTON"];
					DEFAULT_CHAT_FRAME:AddMessage( EMCC_STRING["EQUIP_CHANNEL"] );
					SwapEquipmentItem();
				elseif ( g_emccMode == EMCC_MODE["PUTON"] ) then
					-- 脱いだものを付け終わったので、モードをリセットする
					g_emccMode = EMCC_MODE["NONE"];
					DEFAULT_CHAT_FRAME:AddMessage( EMCC_STRING["EQUIP_END"] );
				end
			end
		end
		
		-- 周期リセット
		g_emccRemaining = EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_INTERVAL];
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 装備着脱
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:EquipShareItem()
	if ( EMCC_PROFILES[g_emccRealm][g_emccChar][g_emccSlotCnt] ~= "" ) then
		-- 共用装備を置くスロットなら
		if ( g_emccMode == EMCC_MODE["PULLOFF"] ) then
			-- 脱ぐ
--			DEFAULT_CHAT_FRAME:AddMessage(
--									string.format(
--										EMCC_STRING["EQUIP_PULLOFF"],
--										EMCC_PROFILES[g_emccRealm][g_emccChar][g_emccSlotCnt] ) );
			EquipItem(g_emccSlotCnt);
		elseif ( g_emccMode == EMCC_MODE["PUTON"] ) then
			-- 脱いだものをつける
			for j = EMCC_SEARCH_START, EMCC_SEARCH_END do
				local slot,icon,name = GetBagItemInfo(j);
				if ( string.find( name, EMCC_PROFILES[g_emccRealm][g_emccChar][g_emccSlotCnt] ) ) then
--					DEFAULT_CHAT_FRAME:AddMessage(
--											string.format(
--												EMCC_STRING["EQUIP_PUTON"],
--												EMCC_PROFILES[g_emccRealm][g_emccChar][g_emccSlotCnt] ) );
					EquipItem( g_emccSlotCnt, slot );
					break;
				end
			end
		end
		-- 着脱処理完了
		g_emccSlotCnt = g_emccSlotCnt + 1;
		return true;
	else
		-- 着脱の必要なし
		g_emccSlotCnt = g_emccSlotCnt + 1;
		return false;
	end
end


--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- インターバルのみ表示
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:IntervalShow()
	local strInterval = tostring( emccSlider:GetValue() );
	emccTxtInterval:SetText( string.format( EMCC_STRING["INTERVAL"], string.sub( strInterval, 1, EMCC_INTERVAL_LEN ) ) );
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 表示
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:OnShow()
	-- ラベル
	emccTxtVer:SetText( EMCC_VERSION );
	emccTxtShare:SetText( EMCC_STRING["SHAREITEM"] );
	emccTxtNoChange:SetText( EMCC_STRING["NOCHANGE"] );

	-- 装備変更なしフラグ
	emccChkNoChange:SetChecked( EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_NOCHANE] );

	-- スライダー
	emccSlider.loading=1;
	emccSlider:SetValueStepMode( "FLOAT" );
	emccSlider:SetMinMaxValues( EMCC_NIN_INTERVAL, EMCC_MAX_INTERVAL );
	emccSlider.loading=0;
	emccSlider:SetValue( EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_INTERVAL] );
--	local strInterval = tostring( EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_INTERVAL] );
--	emccTxtInterval:SetText( string.format( EMCC_STRING["INTERVAL"], string.sub( strInterval, 1, EMCC_INTERVAL_LEN ) ) );
	emClassChanger:IntervalShow();

	-- 装備
	emccTxt1:SetText(  emClassChanger:ShowItemname(  emccChk1, EMCC_KEY_HEAD ) );
	emccTxt2:SetText(  emClassChanger:ShowItemname(  emccChk2, EMCC_KEY_HAND ) );
	emccTxt3:SetText(  emClassChanger:ShowItemname(  emccChk3, EMCC_KEY_FOOT ) );
	emccTxt4:SetText(  emClassChanger:ShowItemname(  emccChk4, EMCC_KEY_CHEST ) );
	emccTxt5:SetText(  emClassChanger:ShowItemname(  emccChk5, EMCC_KEY_LEG ) );
	emccTxt6:SetText(  emClassChanger:ShowItemname(  emccChk6, EMCC_KEY_CAPE ) );
	emccTxt7:SetText(  emClassChanger:ShowItemname(  emccChk7, EMCC_KEY_BELT ) );
	emccTxt8:SetText(  emClassChanger:ShowItemname(  emccChk8, EMCC_KEY_SHOULDER ) );
	emccTxt9:SetText(  emClassChanger:ShowItemname(  emccChk9, EMCC_KEY_NECK ) );
	emccTxt10:SetText( emClassChanger:ShowItemname( emccChk10, EMCC_KEY_AMMO ) );
	emccTxt11:SetText( emClassChanger:ShowItemname( emccChk11, EMCC_KEY_RANGE ) );
	emccTxt12:SetText( emClassChanger:ShowItemname( emccChk12, EMCC_KEY_RINGR ) );
	emccTxt13:SetText( emClassChanger:ShowItemname( emccChk13, EMCC_KEY_RINGL ) );
	emccTxt14:SetText( emClassChanger:ShowItemname( emccChk14, EMCC_KEY_EARR ) );
	emccTxt15:SetText( emClassChanger:ShowItemname( emccChk15, EMCC_KEY_EARL ) );
	emccTxt16:SetText( emClassChanger:ShowItemname( emccChk16, EMCC_KEY_MAINARM ) );
	emccTxt17:SetText( emClassChanger:ShowItemname( emccChk17, EMCC_KEY_OFFHAND ) );
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 装備しているアイテム名を取得
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:GetInventoryItemName(idx)
	-- GetInventoryItemDurableはインデックスが１からではなく0始まりらしいので-1
	local curD, maxD, itemName, curDfull, maxDfull = GetInventoryItemDurable( "player", idx -1 );
	
	-- バンヘルディー対策
	-- (A)とか(B)とかがあると動かなくなるので最後の3文字だけ取り払う
	if ( itemName == nil ) then
		return nil;
	else
		if ( ( string.find( itemName, "(A)" ) ) or ( string.find( itemName, "(B)" ) ) ) then
			local len = string.len( itemName );
			local name = string.sub( itemName, 1, len - 3 ); 
			return name;
		else
			return itemName;
		end
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 装備しているアイテム名を表示
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:ShowItemname(chk, idx)
	local itemName = emClassChanger:GetInventoryItemName( idx );
	if ( itemName ~= nil ) then
		if ( EMCC_PROFILES[g_emccRealm][g_emccChar][idx] ~= "" ) then
			chk:SetChecked( true );
		else
			chk:SetChecked( false );
		end
		
		chk:Show();
		return itemName;
	else
		chk:SetChecked( false );
		chk:Hide();
		return "";
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 設定保存
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:Save()
	-- 装備変更なしフラグ
	EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_NOCHANE] = emccChkNoChange:IsChecked();

	-- インターバル
	EMCC_PROFILES[g_emccRealm][g_emccChar][EMCC_KEY_INTERVAL] = emccSlider:GetValue();
	
	-- 装備
	emClassChanger:SaveItemName(emccChk1:IsChecked(), EMCC_KEY_HEAD);
	emClassChanger:SaveItemName(emccChk2:IsChecked(), EMCC_KEY_HAND);
	emClassChanger:SaveItemName(emccChk3:IsChecked(), EMCC_KEY_FOOT);
	emClassChanger:SaveItemName(emccChk4:IsChecked(), EMCC_KEY_CHEST);
	emClassChanger:SaveItemName(emccChk5:IsChecked(), EMCC_KEY_LEG);
	emClassChanger:SaveItemName(emccChk6:IsChecked(), EMCC_KEY_CAPE);
	emClassChanger:SaveItemName(emccChk7:IsChecked(), EMCC_KEY_BELT);
	emClassChanger:SaveItemName(emccChk8:IsChecked(), EMCC_KEY_SHOULDER);
	emClassChanger:SaveItemName(emccChk9:IsChecked(), EMCC_KEY_NECK);
	emClassChanger:SaveItemName(emccChk10:IsChecked(), EMCC_KEY_AMMO);
	emClassChanger:SaveItemName(emccChk11:IsChecked(), EMCC_KEY_RANGE);
	emClassChanger:SaveItemName(emccChk12:IsChecked(), EMCC_KEY_RINGR);
	emClassChanger:SaveItemName(emccChk13:IsChecked(), EMCC_KEY_RINGL);
	emClassChanger:SaveItemName(emccChk14:IsChecked(), EMCC_KEY_EARR);
	emClassChanger:SaveItemName(emccChk15:IsChecked(), EMCC_KEY_EARL);
	emClassChanger:SaveItemName(emccChk16:IsChecked(), EMCC_KEY_MAINARM);
	emClassChanger:SaveItemName(emccChk17:IsChecked(), EMCC_KEY_OFFHAND);
	
	-- スロットチェック
	emClassChanger:CheckValidSlot();
		
	SaveVariables( "EMCC_PROFILES" );

	emClassChanger:OnShow();
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 設定保存
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:SaveItemName( chked, idx )
	local itemName = emClassChanger:GetInventoryItemName( idx );

	if ( ( itemName ~= nil ) and ( chked ) ) then
		EMCC_PROFILES[g_emccRealm][g_emccChar][idx] = itemName;
	else
		EMCC_PROFILES[g_emccRealm][g_emccChar][idx] = "";
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 装備変更時
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:PLAYER_INVENTORY_CHANGED()
	if ( g_emccMode == EMCC_MODE["NONE"] ) then
		if ( emccConfig_Frame:IsVisible() ) then
			-- フレームを再表示
			emccConfig_Frame:Hide();
			emccConfig_Frame:Show();
		end
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- AddonManagerへの登録
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emClassChanger:RegistAddonManager()
	if (AddonManager) then
		local addon = {
			name = EMCC_MYNAME,
			version = EMCC_VER_AM,
			author = EMCC_STRING["AM_AUTHOR"],
			description = EMCC_STRING["AM_DISC"],
  	 		icon = "interface\\characterframe\\equipswapbutton-normal.tga",
			category = "Miscellaneous",
			configFrame = emccConfig_Frame, 
			slashCommands = SLASH_emClassChanger2,
			miniButton = emccAddonManagerMiniButton,
		};
		if AddonManager.RegisterAddonTable then
			AddonManager.RegisterAddonTable(addon);
		else
			AddonManager.RegisterAddon(addon.name, addon.description, addon.icon, addon.category, addon.configFrame, addon.slashCommand, addon.miniButton, addon.version, addon.author, addon.onClickScript);
		end
	end
end
